import java.util.Scanner; 

/**
 * Write a description of class ExcTester here.
 *
 * @author Pete Lemieszewski
 * @version 0.91 pre-release
 */
public class ExcTester {
    // An interface - either an application programming interface (api),
    // or an interactive/user interface, can be considered a "contract". 
    // Violate the terms of that contract and you have committed an exception. 	

    ExcTester() {
        // Even though a constructor is a method, exceptions are not 
        // generally thrown in constructors.
        // There are, however, exceptions!
        // If a constructor accepts input parameters, It is prudent to
        // verify that they are correct. These are my recommended set of 
        // exceptions to use in constructors. 
        // IllegalArgumentException, 
        // NullPointerException or 
        // IllegalStateException		
    }

    public void interactive() {
        System.out.println("\n We have seen code like this before in our interactive lab, Calendar1752. \n");  
        System.out.println("\n Please enter a number... \n");
        Scanner scanner = new Scanner(System.in); 

        while(true){
            String inputStr = scanner.next();

            int inputInteger;
			inputInteger = Integer.parseInt(inputStr); // modify - comment out for part 2
            /*
             * part 2 here, comment out the declaration for inputInteger above
             * uncomment this try/catch block below.
             * Exceptions are thrown and exceptions are caught - just like playing catch!
             * But, you have to get out there and try!
             * given that cheesy admonition, 
             * you enclose one or more statements in a try block to look for an exception.
             * you enclose one or more statements in a catch block...
             * to catch any/all exceptions that could possibly be thrown in the try code block.
			 * /
            try {
               int inputInteger = Integer.parseInt(inputStr);
            } 
            catch(NumberFormatException e) {
               System.out.println("Whatever you entered is not correct. We need a number!\n");
               continue; // where do we pick up the action after a continue?
            }
             */			
            if (inputInteger == 0)
                return; // we could "break;" instead - the program will break out of while loop instead of method.

            // do something interesting with inputInteger, like...
            System.out.printf("\n You entered: %d \n", inputInteger);  
            System.out.println("\n What happens if we try entering data that is Nan? \n");
            // good idea to type or copy/paste an answer here!

        }
        //If we coded "break;" on line 46.  
        //System.out.println("\nDone \n");
    }
    
    public static void main(String[] args) {
        ExcTester x = new ExcTester(); 
        x.interactive();  // move code out of "main" and into a class method.
    }
}